

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>What is a time series? &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script src="../../../_static/js/bootstrap.min.js"></script>
        <script src="../../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
    <link rel="next" title="Time series expressions" href="expressions.html" />
    <link rel="prev" title="Dealing with time" href="time.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../installation.html">Installation</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../concepts.html">Concepts</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="time.html">Dealing with time</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">What is a time series?</a></li>
<li class="toctree-l2"><a class="reference internal" href="expressions.html">Time series expressions</a></li>
<li class="toctree-l2"><a class="reference internal" href="dts.html">DTSS - Distributed Time Series System</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../concepts.html">Concepts</a> &raquo;</li>
        
      <li>What is a time series?</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../../_sources/content/time_series/concepts/time_series.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  
<style>
/* CSS overrides for sphinx_rtd_theme */

/* 24px margin */
.nbinput.nblast.container,
.nboutput.nblast.container {
    margin-bottom: 19px;  /* padding has already 5px */
}

/* ... except between code cells! */
.nblast.container + .nbinput.container {
    margin-top: -19px;
}

.admonition > p:before {
    margin-right: 4px;  /* make room for the exclamation icon */
}

/* Fix math alignment, see https://github.com/rtfd/sphinx_rtd_theme/pull/686 */
.math {
    text-align: unset;
}
</style>
<div class="section" id="what-is-a-time-series">
<span id="concepttimeseries"></span><h1>What is a time series?<a class="headerlink" href="#what-is-a-time-series" title="Permalink to this headline">¶</a></h1>
<p>A time series in Shyft is considered to be a function of time, f(t) -&gt; float.</p>
<p>This is more general, and different from many systems and popular libraries,
that consider and represents, time-series as a sequence of time-value pairs,
often tied together using some clever indexing scheme.</p>
<p>We enable users to work with time-series as a function, and thus also enabling
the mathematical and statistical skills of the users.</p>
<p>This also allows for composition, of functions, expressions that have well defined
and known results. Another important aspect is that it allows for defining expressions,
and evaluating those lazy, later, at another server(the backend).</p>
<p>So, in Shyft, time-series are f(t).</p>
<p>A simple example to illustrate how this changes the focus of the code into generic,
always valid mathematical formulas and definitions.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="p">(</span><span class="n">TimeSeries</span><span class="p">,</span><span class="n">TimeAxis</span><span class="p">)</span>


<span class="k">def</span> <span class="nf">income</span><span class="p">(</span><span class="n">spot_price</span><span class="p">:</span> <span class="n">TimeSeries</span><span class="p">,</span> <span class="n">production</span><span class="p">:</span> <span class="n">TimeSeries</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">TimeSeries</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;&quot; returns income rate in SI units [EUR/s]&quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">spot_price</span> <span class="o">*</span> <span class="n">production</span>  <span class="c1"># unit analysis: [EUR/s] x [J/s] -&gt; [ EUR/s]</span>


<span class="k">def</span> <span class="nf">periodic_income</span><span class="p">(</span><span class="n">income</span><span class="p">:</span><span class="n">TimeSeries</span><span class="p">,</span><span class="n">income_periods</span><span class="p">:</span><span class="n">TimeAxis</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">TimeSeries</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; returns income in SI unit [EUR] for each of the income_periods specified&quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">income</span><span class="o">.</span><span class="n">integral</span><span class="p">(</span><span class="n">income_periods</span><span class="p">)</span> <span class="c1"># unit analysis: [EUR/s] x dt[s] -&gt; [EUR]</span>
</pre></div>
</div>
<p>For a classical definition of time-series, please check <a class="reference external" href="https://en.wikipedia.org/wiki/Time_series">Wikipedia - Time series</a>.
And also important reference to functions, also check <a class="reference external" href="https://en.wikipedia.org/wiki/Function_(mathematics)">Wikipedia - Functions</a>.</p>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="expressions.html" class="btn btn-neutral float-right" title="Time series expressions" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="time.html" class="btn btn-neutral float-left" title="Dealing with time" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>